<%--
 * Component:
 *
 * Description:
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
 * --%>
<%@page import="imagemed.types.flag.IMTypeur"%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@

	page import="imagemed.imsession.*,imagemed.util.*,imagemed.http.*,java.util.*,
  						  imagemed.tables.*, imagemed.imtables.*,imagemed.jsputil.*"

%><%
	IMSession is = new IMSession(request, response, out); 
	if (!is.regOK()) {
		return;
	}
	IMRequest parReq = is.imRequest;
	String context = parReq.m_context;
	if (context == null || context.length() == 0) {
		context = parReq.backupContext();
	}
	else {
		parReq.passAsFile(context);
	}

	String thisPage = "/imadmin/groups.jsp";

	String fields[]    = TableParams.getDefaultFields(thisPage, is);
	String sort[]      = TableParams.getDefaultSorts(thisPage);
	String extraPars[] = {"cLogged"};

	String timeOut = is.secProp.getProperty("optTimeout");
	if (timeOut == null)
		timeOut = "60";
	else
		timeOut = timeOut.replace('\"',' ').trim();
		

	TableDescriptor tdesc = new TableDescriptor(thisPage);
	TableProperties tprop = new TableProperties();

	TableParams tparams = new TableParams(is.imRequest);
	tparams.setDefaultFields(fields);
	tparams.setDefaultSort(sort);
	tparams.setDefaultPage(1);
	tparams.setDefaultPageSize(20);
	tparams.setExtraParams(extraPars);

	tdesc.setTableParams(tparams);

	tdesc.setTableProperties(tprop);
	tdesc.setFieldManager(new IMFieldManager("Dcfields", "Dctypes", "Groups"));
	tdesc.setSortDepth( 3 );


	Action acts[] = new Action[3];

  acts[0] = new LinkAction(tdesc, "GRID", "chgroup.jsp?cID=$$GRID$$&cOp=View",
    "<script language=javascript>"+
 		"getImage2node(false, \"qview.gif\", 0, 0, \"" + LocalizedMessage.getSimpleMessage( "IMADMIN_GROUPS_VIEW_DETAILS" ) + "\");"+
 		"</script>", null);
  acts[1] = new LinkAction(tdesc, "GRID", "chgroup.jsp?cID=$$GRID$$&cOp=Edit",
    "<script language=javascript>"+
 		"getImage2node(false, \"edit.gif\", 0, 0, \"" + LocalizedMessage.getSimpleMessage( "IMADMIN_GROUPS_EDIT_DETAILS" ) + "\");"+
 		"</script>", null);
  acts[2] = new LinkAction(tdesc, "GRID", "chgroup.jsp?cID=$$GRID$$&cOp=Delete",
    "<script language=javascript>"+
 		"getImage2node(false, \"delete.gif\", 0, 0, \"" + LocalizedMessage.getSimpleMessage( "IMADMIN_GROUPS_DELETE_DETAILS" ) + "\");"+
 		"</script>", null);
	
	Action act[] = new Action[1];
	act[0] = new MultiAction(tprop, acts);

	Column col = new Column(new SimpleHeader( LocalizedMessage.getSimpleMessage( "IMADMIN_GROUPS" ) ), new ActionCell("GRPID", act), "GRID");

	tdesc.addExtraColumn("_FIRST",col);

	List<TopCell> topCells = new ArrayList<TopCell>();
	topCells.add(new TitleTopCell(tprop, LocalizedMessage.getSimpleMessage( "IMADMIN_GROUPS" ) ));
	List<String[]> pageMap = new ArrayList<String[]>();
	
	if( is.hasRight( IMTypeur.USER_MANAGE_RIGHT + IMTypeur.SUPPORT_RIGHT_FOR_SUPPORT_USER ) ) {
		pageMap.add(new String[]{"/imadmin/users.jsp", LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_USERSLIST" ) });
	}
	if( is.hasRight( IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT ) ) {
		pageMap.add(new String[]{thisPage, LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_GROUPLIST" ) });
	}
	topCells.add(new PageSelectorTopCell(tprop, pageMap, thisPage));
	topCells.add(new SeparatorTopCell(tprop, 4));
	topCells.add(new SimpleTopCell(tprop,
                             "<A href=\"chgroup.jsp?cOp=New\" onMouseOver=\"window.status='" +
                             "Add new group'; return true;\">"+JSHelper.getJsButton(is, "newButton", LocalizedMessage.getSimpleMessage( "ALT_TEXT_CREATE_GROUP" ) ) +"</a>"));
	topCells.add(new SeparatorTopCell(tprop, 4));
  topCells.add(new FieldsTopCell(tdesc, null, true));
	topCells.add(new FiltersTopCell(tdesc, null, false, new String[0], false));
	topCells.add(new SortsTopCell(tdesc, null, false, true));
	topCells.add(new PageTopCell(tprop, tparams));

	tdesc.setTopCells(topCells);

	//getting the data from sql table
	SQLResult result = new SQLResult(tdesc, new String[] {"GRID"});

  
	tdesc.setResult(result);


	Table table = new Table(tdesc);
%>
<HTML>
  <HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "IMADMIN_GROUPS" ) %></TITLE>
 <SCRIPT Language="JavaScript">
 	var pageContext="<%=context%>";
 </script>
<%
		TabToolbox.writeIMpopup(out);
		table.printScript(tparams, is);
%>
    <script language="JavaScript">
    
			function doSubmit(frm,val)
			{
				frm.cLogged.value = val;
				frm.submit();
			}
    </script>
                                
    </HEAD>
    <BODY><CENTER>
<%
    TabToolbox.makeTabs( is, is.tabbean, "imadmin/users.jsp", "White");

    if( !is.hasRight( IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT ) ) {
%>
  <BR>
  <H3><%= LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ) %></H3></CENTER>
  </BODY></HTML>
<%
      return;
    }
	try {
  table.printTableTop(is);
	}
	catch (Throwable th) {
		Helper.DEBUG("groups.jsp", Helper.throwable2String(th));
	}
  table.print(is);
%>

</CENTER>
</BODY></HTML>
