<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.tables.*, imagemed.imtables.*, imagemed.http.IMRequest, imagemed.util.*,
			imagemed.imsession.*, imagemed.jsputil.*, imagemed.layout.*, imagemed.lists.*,
			imagemed.layout.datasource.*, imagemed.scheduler.SchedulerInterface, java.util.*,
			java.sql.Statement, imagemed.filters.*, imagemed.dotcom.DotcomConfig,
			java.io.File, imagemed.types.IMType"
	
%><%!

	static String thisPage = "/imadmin/logs.jsp";

%><%

	IMSession is = new IMSession(request, response, out);

	if (!is.regOK()) {
		return;
	}
	IMRequest reqPar  = is.imRequest;
	String parOper = is.getButtonParam("cOp");
	String parLog = reqPar.getVal("c0LID");
	String context = reqPar.m_context;
	boolean contextChanged = false;
	String selfID = DotcomConfig.selfId();
  
	if( !Table.isExporting(is) ) {
		is.setNonCacheable();
		if( !reqPar.digUpParameterNames().contains( "qf_0LED") ) {
			reqPar.setProperty( "qf_0LED", "(-24 hours)()()" );
			contextChanged = true;
		}
/*		
		if( !reqPar.digUpParameterNames().contains( "qf_0LLS") ) {
			if ( selfID != null ) {
				reqPar.setProperty( "qf_0LLS", selfID );
				contextChanged = true;
			}
		}
*/
	  if (parOper == null) {
		  if (context == null || context.length() == 0) {
	  		context = reqPar.backupContext();
	  		// we did not have a context, redirect the page now.
	  		response.sendRedirect(thisPage+"?cContext="+context);
	  		return;
		  }
	  	else {
	  		// just save the context
	  		reqPar.passAsFile(context);
	  		if( contextChanged ) {
					is.createIMRequest( true );	  			
	  		}
		  }
	  }
  }

	
	
  IMBaseFieldManager fm = EntryLayoutFactory.getDefaultFieldManager(is, LayoutPart.SCHLOGLAYOUT);

  // --- Init Table without Result ---
  
  String thisPageMenuTab = thisPage.substring(1);

  TableDescriptor tdesc = new TableDescriptor(thisPage,true,true,true,false);
  TableProperties tprop = new TableProperties();

	WorklistTableParams tparams = new WorklistTableParams( is, is.getProfileUser(), is.regRights.indexOf('A') > -1, is.isRegisteredViewer());  
  tparams.setDefaults(thisPage, is);
    
  tdesc.setFieldManager(fm);
  tdesc.setTableParams(tparams);
  tdesc.setTableProperties(tprop);
  tdesc.setSortDepth(3);

	Properties filterPrp = tdesc.getFilters();

  String parLogserverQuery = filterPrp.getProperty( "0LLS" ); 
  	//reqPar.getVal("qf_0LLS"); 
  
	boolean collect = true;
	if( selfID == null || DotcomConfig.selfChildren() == null || DotcomConfig.selfChildren().length == 0 ) {
		collect = false;
	}
	else {
  	IMFilterString fs = new IMFilterString();
  	fs.parseFilterString( parLogserverQuery );
  	IMFilterStringPart[] parts = fs.getFilterStringParts();
  	if( parts.length == 1 && parts[ 0 ].getContent( true, true ).equals( selfID ) ) {
  		collect = false;
  	}
  }

  if( !collect ) {
  	Action act[] = new Action[1];
  	act[0] = new LinkAction(tdesc, "0LID", "javascript:redirPage_b(\"logs.jsp?c0LID=$$0LID$$&cOp=View\")", 
  		"<script language=\"JavaScript\">getImage(\'qview\', 18, 20, \' alt=\"View Log\" title=\"View Log\"\');</script>", 
  		"View Log");

  
  	Column col = new Column(new SimpleHeader("&nbsp;"), new ActionCell("0LID", new Action[]{new MultiAction(tprop, act)}), "0LID");
		tdesc.addExtraColumn("_FIRST",col);
  }
  
	List<TopCell> topCell = new ArrayList<TopCell>();

  TitleTopCell title = new TitleTopCell(tprop, LocalizedMessage.getSimpleMessage( "tabLogs" ) );
  title.clearWidth();
  
  topCell.add( title );
  
  topCell.add( new SeparatorTopCell(tprop, 4) );

  topCell.add( new ListsTopCell( ListType.SCHEDULER_LOG, tdesc, is.getProfileUserId(), true) );

//	topCell.add( new SeparatorTopCell(tprop, 4) );
//	topCell.add( new ShowArchiveLogsTopCell( tdesc ) );
//	topCell.add( new SeparatorTopCell(tprop, 4) );

  topCell.add( new FieldsTopCell(tdesc, null, true) );
  topCell.add( new FiltersTopCell(tdesc, null, false, new String[0], true) );
  topCell.add( new SortsTopCell(tdesc, null, false, true) );
  
  topCell.add( new PageTopCell(tprop, tparams) );
  tdesc.setTopCells(topCell);
    


  // --- Init Table with Result ---
  if( Table.isExporting(is) ) {
  	tparams.setPageSize( -1 );
  }
  
  Result result;
  
  if( collect ) {
  	result = new CollectedLogsResult( fm, tparams, new String[] { "0LLD", "0LID", "0LTP", "0LTD" }, is );
  }
  else {
    result = new DBLogsResult(tdesc, is, new String[] {"0LOI","0LED"}, false, false );
  }

  tdesc.setResult(result);
  Table table = new Table(tdesc);

	if (table.handleExport(is))	{
		return;
	}

%><%-- --- HTML --- --%><HTML>
<HEAD><TITLE><%=LocalizedMessage.getSimpleMessage( "tabLogs" )%></TITLE>
 <SCRIPT Language="JavaScript">
 	var pageContext="<%=context%>";
 </script>
<%
	TabToolbox.writeIMpopup(is.out);
    table.printScript(tparams,is);
%>
  <SCRIPT language="JavaScript">
		function doSubmit(frm, mod) {
			while (frm.cOp.value != mod) {
				frm.cOp.value=mod;
			}
			frm.submit();
		}


  </script>
</head>

<BODY>
<%
	TabToolbox.makeTabs( is,is.tabbean, thisPageMenuTab, "White");
	// --- Oper ---

  if ("View".equals(parOper) ) {
  	SchedulerInterface.putLabel( is, "IMADMIN_LOGS_LOG", parOper );

		Statement st = IMEnv.getDB().createStatement();
		String query = "select LOGID from LogView where LOGID=" + parLog;
		boolean isCurrent = st.executeQuery( query ).first();
  	DBLayoutDataSource dblds = EntryLayoutFactory.getDefaultDBLDS(is, isCurrent ? LayoutPart.SCHLOGLAYOUT : LayoutPart.SCHLOGARCHIVELAYOUT );

		DBLDSEntry entry = new DBLDSEntry(dblds);
		dblds.setEntry(entry);
		entry.initFromExisting(parLog);
  	dblds.setRepeatPointer(dblds.getTable(), 0);

//   	dblds.setRowID(parLog);
  	OperatingMode mode = LayoutPart.VIEWING;
		LayoutRoot root = imagemed.layout.cache.LayoutCache.getSystemLayout(is, LayoutPart.SCHLOGLAYOUT);
  	String html = root.getHtml("  ", mode, dblds);

   	out.println(html);
%>
</body>
</html>
<%		  	
  	return;
  }
%>
<CENTER>
<%
  table.printTableTop(is);
  table.print(is);
%>
</CENTER>
<%=ListSaveForm.getListSaveForm( ListType.SCHEDULER_LOG, is, tdesc)%>
<%

	String oldLogs = LocalizedMessage.getSimpleMessage( "VIEW_IMADMIN_CLASSIC_LOGS_PAGE" );	
/*
		"Old PACS Logs";
	String confFileName = IMEnvBase.getEnv( "CONF" ) + "/newversion.conf";
	File confFile = new File( confFileName );
	if( confFile.exists() ) {
		IMPropsConfigReader cr = new IMPropsConfigReader( confFileName );
		cr.checkAndLoad();
		Properties pr = ( (IMPropsConfiguration) cr.getConfiguration() ).getProperties();
		if( pr != null && pr.getProperty( "date" ) != null ) {
			IMType da = IMType.getTypeFor( "DA" );
			oldLogs = "PACS Logs before " + da.displayText( pr.getProperty( "date" ) );
		}
	}
*/	
%>
<A HREF=oldlogs.jsp><%=oldLogs%></A>

</BODY>
</HTML>