<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.imsession.*, imagemed.util.*, imagemed.http.*, imagemed.exception.*,
			imagemed.tables.*, imagemed.imtables.*,imagemed.jsputil.*,java.util.*, java.text.*,
			imagemed.types.flag.IMTypeur"
%><%!
	static Set<String> nonContextParams = new HashSet<String>();
	static {
		nonContextParams.addAll( Arrays.asList(new String[]{ 
				"cOp",
				"isNew",
				"shouldReset",
				"creator",
				"lifetime",
				"x",
				"y",
				"timeMultiplier",
				IMMessage.MESSAGENAME,
				IMMessage.CONTENT,
				IMMessage.SHOWOK,
				IMMessage.SHOWBORDER,
				IMMessage.BORDERCOLOR
		}) );
	}

%><%IMSession is = new IMSession(request, response, out); 
  if (!is.regOK()) {
    return;
  }

  is.setNonCacheable();
  
  IMRequest parReq = is.imRequest;
  String context = parReq.m_context;
  if (context == null || context.length() == 0) {
  	context = parReq.backupContextExcept(nonContextParams);
  }
  else {
  	parReq.passAsFileExcept(context, nonContextParams);
  }

  String thisPage = "/imadmin/messages.jsp";
	String tabPage = "imadmin/messages.jsp";

  // action handling here!
  StringBuffer html = new StringBuffer();
  String message = request.getParameter(IMMessage.MESSAGENAME);
  String parOp = request.getParameter("cOp");
  boolean isNew = "New".equals(parOp);
  boolean isEdit = "Edit".equals(parOp);
  if (message != null || isNew) {
  	if (!is.hasRight( IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT + IMTypeur.SUPPORT_RIGHT_FOR_SUPPORT_USER ) ) {
  		throw new IMException( LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_RIGHT_CREATE_ALTER" ) );
  	}
	  if ("Delete".equals(parOp)) {
	  	if ("true".equals(request.getParameter("cConfirmed"))) {
	  		IMMessage.delete(message);
	  	}
	  	else {
	  		throw new IMConfirmationException( "<center>" + LocalizedMessage.getCompoundMessage( "EXCEPTION_MESSAGES_DELETE_MESSAGE", new Format[] { null }, new Object[] { message }, true) + "</center>",
	  			tabPage, LocalizedMessage.getCompoundMessage( "EXCEPTION_MESSAGES_DELETE_MESSAGE_TITLE", new Format[] { null }, new Object[] { message }, true), null, request.getRequestURL()+"?"+request.getQueryString()+"&cConfirmed=true");
	  	}
	  }
	  if (isNew || isEdit) {
	  	if (isNew) {
	  		html.append(Helper.getTitlePart( LocalizedMessage.getSimpleMessage( "IMADMIN_MESSAGES_NEW_MESSAGE" ) + "\n"));
	  	}
	  	else {
	  		html.append(Helper.getTitlePart( LocalizedMessage.getSimpleMessage( "IMADMIN_MESSAGES_EDIT_MESSAGE" ) + " " +message+"\n"));
	  	}
	  	html.append("<form method=post action=\"messages.jsp\">\n");
	  	html.append("<input type=hidden name=\"cContext\" value=\""+context+"\">\n");
	  	html.append("<input type=hidden name=\"cOp\" value=\"Save\">\n");
	  	if (isNew) {
		  	html.append("<input type=hidden name=\"isNew\" value=\"true\">\n");
	  	}
	  	IMMessage msg = new IMMessage();
	  	if (isEdit) {
	  		msg.load(message);
	  	}
	  	html.append(msg.getEditForm(is, isNew?is.regID:null)+"\n");
	  	html.append("</form>\n");
	  }
	  if ("Save".equals(parOp)) {
	  	IMMessage msg = new IMMessage();
	  	if ("true".equals(request.getParameter("isNew"))) {
	  		if (IMMessage.exists(message) && !"true".equals(request.getParameter("cConfirmed"))) { 
	  			String confirmMessage = LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_NAME_ALREADY_EXISTS" );
	  			confirmMessage += "<form method=post>\n";
	  			confirmMessage += "<input type=hidden name=\"cConfirmed\" value=\"true\">\n";
	  			confirmMessage += is.imRequest.passAsFormAll();
	  			confirmMessage += "</form>\n";
	  			throw new IMConfirmationException(confirmMessage, tabPage, "Message "+message, null, "JavaScript:document.forms[0].submit()");
	  		}
	  		if (!IMMessage.isMessageNameValid(message)) {
	  			throw new IMGeneralException(LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_ILLEGAL_CHAR" ), tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_ILLEGAL_CHAR_TITLE" ), null);
	  		}
	  	}
  		msg.parseEditResult(is.imRequest);
  		msg.save();
	  }
	  if ("View".equals(parOp)) {
  		html.append(Helper.getTitlePart( LocalizedMessage.getSimpleMessage( "IMADMIN_MESSAGES_VIEW_MESSAGE" ) + " "+message));
	  	IMMessage msg = new IMMessage();
  		msg.load(message);
	  	html.append(msg.generateQuickView(is));
	  }
	  if ("Rename".equals(parOp)) {
	  	String newName = request.getParameter("cNewName");
	  	if (newName != null) {
	  		if (!IMMessage.isMessageNameValid(newName)) {
	  			throw new IMGeneralException(LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_ILLEGAL_CHAR" ), tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_ILLEGAL_CHAR_TITLE" ), null);
	  		}
	  		if (!newName.equals(message) && IMMessage.exists(newName) && !"true".equals(request.getParameter("cConfirmed"))) {
	  			String confirmMessage = LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_NAME_ALREADY_EXISTS" );
	  			confirmMessage += "<form method=post>\n";
	  			confirmMessage += "<input type=hidden name=\"cConfirmed\" value=\"true\">\n";
	  			confirmMessage += is.imRequest.passAsFormAll();
	  			confirmMessage += "</form>\n";
	  			throw new IMConfirmationException(confirmMessage, tabPage, LocalizedMessage.getCompoundMessage( "EXCEPTION_MESSAGES_DELETE_MESSAGE_TITLE", new Format[] { null }, new Object[] { message }, true), null, "JavaScript:document.forms[0].submit()");
	  		}
	  		IMMessage.rename(message, newName);
	  	}
	  	else {
	  		html.append("<font face=\"Arial,Helvetica,Universe\">\n");
	  		html.append("<h2><p>&nbsp;\n");

  			html.append("<FORM name=\"operForm\" METHOD=\"post\" ACTION='messages.jsp'>\n");
 				html.append("<p>" + LocalizedMessage.getCompoundMessage( "EXCEPTION_MESSAGES_RENAME_MESSAGE", new Format[] { null }, new Object[] { message }, true )+ "\n");
				html.append("<p>\n");
				html.append(LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_NEW_LIST_NAME" ) +": <INPUT type=text name=cNewName size=16 maxlength=32><br>\n");
				html.append("<p>" + LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_ARE_YOU_SURE" ) + "<br>\n");
				html.append(is.imRequest.passAsFormAll()+"\n");
				html.append("</FORM>\n");
				html.append("<a href=\"javascript:document.forms[0].submit()\">"+ JSHelper.getJsLocalizedButton( "BUTTON_RENAME", "BUTTON_NULL", false ) +"</a>\n");
				html.append("<a href=\"javascript:self.history.back()\">"+ JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) +"</a>\n");
				html.append("</center>\n");
				html.append("</body>\n");
				html.append("</html>\n");
	  	}
	  }
  }
  
  String fields[]    = TableParams.getDefaultFields(thisPage, is);
  String sort[]      = TableParams.getDefaultSorts(thisPage);
  String extraPars[] = {};

  TableDescriptor tdesc = new TableDescriptor(thisPage);
  TableProperties tprop = new TableProperties();

  TableParams tparams = new TableParams(is.imRequest);
  tparams.setDefaultFields(fields);
  tparams.setDefaultSort(sort);
  tparams.setDefaultPage(1);
  tparams.setDefaultPageSize(20);
  tparams.setExtraParams(extraPars);

  tdesc.setTableParams(tparams);

  tdesc.setTableProperties(tprop);
  tdesc.setFieldManager(new SystemMessageFieldManager());


  Action acts[] = new Action[4];

  acts[0] = new LinkAction(tprop, "MESG", "messages.jsp?"+IMMessage.MESSAGENAME+"=$$MESG$$&cOp=View&cContext="+context,
                                           "<IMG SRC=\"/cases/art/qview.gif\" border=0>");
  acts[1] = new LinkAction(tprop, "MESG", "messages.jsp?"+IMMessage.MESSAGENAME+"=$$MESG$$&cOp=Edit&cContext="+context,
                                           "<IMG SRC=\"/cases/art/edit.gif\" border=0>"); 
  acts[2] = new LinkAction(tprop, "MESG", "messages.jsp?"+IMMessage.MESSAGENAME+"=$$MESG$$&cOp=Rename&cContext="+context,
                                           "<IMG SRC=\"/cases/art/rename.gif\" border=0>");
  acts[3] = new LinkAction(tprop, "MESG", "messages.jsp?"+IMMessage.MESSAGENAME+"=$$MESG$$&cOp=Delete&cContext="+context,
  "<IMG SRC=\"/cases/art/delete.gif\" border=0>");

  Action act[] = new Action[1];
  act[0] = new MultiAction(tprop, acts);

  Column col = new Column( new SimpleHeader( LocalizedMessage.getSimpleMessage( "tabMessages" ) ) , new ActionCell("MESG", act), "MESG");

  tdesc.addExtraColumn("_FIRST",col);

  TopCell topCell[] = new TopCell[5];
  topCell[0] = new TitleTopCell(tprop, LocalizedMessage.getSimpleMessage( "IMADMIN_MESSAGES_HTMLPAGE_TITLE" ) );
  topCell[1] = new SimpleTopCell(tprop,
                             "<A href=\"messages.jsp?cOp=New&cContext="+context+"\" onMouseOver=\"window.status='" +
                             "Create new message'; return true;\">"+JSHelper.getJsButton(is, "newButton", 24, 24, LocalizedMessage.getSimpleMessage( "ALT_TEXT_CREATE_NEW_MESSAGE" ))+"</a>");
  topCell[2] = new SeparatorTopCell(tprop, 4);
  topCell[3] = new FiltersTopCell(tdesc, null, false, new String[0], false);
  topCell[4] = new PageTopCell(tprop, tparams);

  tdesc.setTopCells(topCell);

  SystemMessageResult result = new SystemMessageResult(tdesc);

  tdesc.setResult(result);

  Table table = new Table(tdesc);%><HTML>
  <HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MESSAGES_HTMLPAGE_TITLE" ) %></TITLE>
 <SCRIPT Language="JavaScript">
 	var pageContext="<%=context%>";

	var pageStart="<html><head>"+<%= JSHelper.toJSON( JSHelper.getJsInclude( JSHelper.TABLESCRIPTS_JS ) )%>+"</head><body>\n<table border=1 width=100% cellspacing=0 cellpadding=0 class=BgShadow><tr><td class=BgLight>";
	var pageEnd
	
	var previewWindow
	
 	function doPreview() {
 		if (!pageEnd) {
			pageEnd="</td></tr><tr><td align=center><a href='Javascript:window.close();'>";
			var width2 = 91*mul;
			var height2 = 18*mul;
			//pageEnd=pageEnd + "<img SRC=\"/art/b/Close";
			//pageEnd=pageEnd + "<img src=\"/art/buttonize.jsp?cLabel=" + LocalizedMessage.getSimpleMessage( "BUTTON_CLOSE" ) + "\" title alt>" ;
			//if (hires) {
			//	pageEnd=pageEnd + ".big";
			//}			
			//pageEnd=pageEnd + ".gif\" width="+width2+" height="+height2+" border=0>";
			
			pageEnd += <%=JSHelper.toJSON(JSHelper.getJsLocalizedButton( "BUTTON_CLOSE", "BUTTON_NULL" , false , null )) %>;
			pageEnd=pageEnd + "</a></td></tr></body></html>";
		}
 		if (previewWindow && !previewWindow.closed) {
 			previewWindow.focus();
 			previewWindow.document.clear();
 		}
 		else {
    	previewWindow = open( '', '','resizable=yes,scrollbars=yes,width=600,height=300');
    }
    previewWindow.document.writeln(pageStart);
    content=document.forms[0].<%=IMMessage.CONTENT%>.value;
    previewWindow.document.writeln(content);
		previewWindow.document.writeln(pageEnd);
    previewWindow.document.close();
 	}
 	
 </script>
<%
    TabToolbox.writeIMpopup(out);
	JSHelper.printJsInclude( out, JSHelper.JQUERY_JS );

		table.printScript(tparams, is);
%>
    </HEAD>
    <BODY><CENTER>
<%
  TabToolbox.makeTabs( is, is.tabbean, tabPage, "White");

 	if (!is.hasRight( IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT + IMTypeur.SUPPORT_RIGHT_FOR_SUPPORT_USER ) ) {
%>
  <BR>
  <H3><%= LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ) %></H3></CENTER>
  </BODY></HTML>
<%
    return;
  }

	if (html.length() > 0) {
		out.println(html);
		return;
	}

  // redirect if needed
  boolean shouldRedir = is.imRequest.m_context == null || "POST".equals(request.getMethod().toUpperCase());
  if (!shouldRedir) {
  	Enumeration<?> parNames = request.getParameterNames();
  	while (parNames.hasMoreElements() && !shouldRedir) {
  		String parName = (String) parNames.nextElement();
  		if (!parName.equals("cContext") && !parName.equals("cPage")) {
  			shouldRedir = true;
  		}
  	}
  }
	if (shouldRedir) {
		out.println("<script language=\"JavaScript\">document.location='/imadmin/messages.jsp?cContext="+context+"';</script>");
		//response.sendRedirect();
		return;
	}
  
	try {
  table.printTableTop(is);
	}
	catch (Throwable th) {
		Helper.DEBUG("messages.jsp", Helper.throwable2String(th)); 
	}
  table.print(is);
%>

</CENTER>
</BODY></HTML>
