<%--
 * Component: imadmin
 *
 * Description:
 *   Show content of log files
 *
 * Parameters:
 *
--%><%@
 	page import="imagemed.imsession.*, imagemed.jsputil.*, imagemed.exception.*, java.sql.*,java.util.*,
 			imagemed.tables.*, imagemed.imtables.*, imagemed.http.IMRequest, imagemed.lists.*, imagemed.dotcom.*"
 	
%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%IMSession is = new IMSession( request, response, out );

	if ( !is.regOK() ) {
		return;
	}
	if ( !IMAdminToolbox.bAdminRight( is ) && is.regRights.indexOf( "X" ) < 0 ) {
		throw new IMGeneralException(
				"Sorry " + is.regID + ", you don't have the the rights to access logs.",
				"imadmin/oldlogs.jsp", "Logs Error", "/imadmin/oldlogs.jsp" );
	}

	String thisPage = "/imadmin/oldlogs.jsp";
	IMRequest reqPar = is.imRequest;
	String context = reqPar.m_context;
	if ( !Table.isExporting( is ) ) {
		if ( context == null || context.length() == 0 ) {
			//reqPar.expandList(thisPage);
			context = reqPar.backupContext();
			response.sendRedirect( "/imadmin/oldlogs.jsp?cContext=" + context );
			return;
		}
		else {
			reqPar.passAsFile( context );
		}
	}

	// --- Init Table without Result ---

	String thisPageMenuTab = "imadmin/logs.jsp";
	TableDescriptor tdesc = new TableDescriptor( thisPage, true, true, true, false );
	TableProperties tprop = new LogsPageProperties();

	IMLogsFieldManager fm = new IMLogsFieldManager();

	WorklistTableParams tparams = new WorklistTableParams( is, is.getProfileUser(), is.regRights.indexOf( 'A' ) > -1, is.isRegisteredViewer() );

	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( 50 );
	tparams.setDefaults( thisPage, is );
	String dateFilter = tparams.getFilters().getProperty( "TaskDT" );
	if ( dateFilter == null || dateFilter.length() == 0 ) {
		tparams.getFilters().setProperty( "TaskDT", "(-24 hours)()()" );
	}
	else if ( dateFilter.startsWith( "()" ) ) {
		dateFilter = "(-24 hours" + dateFilter.substring( 1 );
		tparams.getFilters().setProperty( "TaskDT", dateFilter );
	}

	tdesc.setFieldManager( fm );
	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );
	tdesc.setSortDepth( 3 );

	List<TopCell> topCell = new ArrayList<TopCell>();

  TitleTopCell title = new TitleTopCell(tprop, "Logs");
  title.clearWidth();
  
  topCell.add( title );
  
  topCell.add( new SeparatorTopCell(tprop, 4) );
	topCell.add( new ListsTopCell( ListType.PACS_LOG, tdesc, is.getProfileUserId(), true ) );

	if ( DotcomConfig.selfChildren() != null && DotcomConfig.selfChildren().length > 0 ) {
		topCell.add( new SeparatorTopCell( tprop, 4 ) );
		topCell.add( new CollectLogsTopCell( tdesc ) );
		topCell.add( new SeparatorTopCell( tprop, 4 ) );
	}

	topCell.add( new FieldsTopCell( tdesc, null, true ) );
	topCell.add( new FiltersTopCell( tdesc, null, false, new String[ 0 ], false ) );
	topCell.add( new SortsTopCell( tdesc, null, false, false ) );
	topCell.add( new PageTopCell( tprop, tparams ) );
	tdesc.setTopCells( topCell );

	// --- Init Table with Result ---

	IMLogsResult lr = new IMLogsResult( tdesc, is );
	tdesc.setResult( lr );
	Table table = new Table( tdesc );
	if ( Table.isExporting( is ) ) {
		tparams.setPageSize( -1 );
	}
	if ( table.handleExport( is ) ) {
		return;
	}

	is.response.setHeader( "pragma", "no-cache" );
	is.response.setHeader( "Cache-Control", "no-cache, must-revalidate" );
	is.response.setHeader( "Expiry-Date", "Friday, 31-Dec-70 23:59:59 GMT" );%><%-- --- HTML --- --%><HTML>
<HEAD>
<TITLE>Logs</TITLE>
<SCRIPT Language="JavaScript">
 	var pageContext="<%=context%>";
 </script>
<%
	TabToolbox.writeIMpopup( is.out );
	table.printScript( tparams, is );
%>
</head>

<BODY>
<%
	TabToolbox.makeTabs( is, is.tabbean, thisPageMenuTab, "White" );
%>
<CENTER>
<%
	table.printTableTop( is );
	table.print( is );

	out.println( ListSaveForm.getListSaveForm( ListType.PACS_LOG, is, tdesc ) );
%>
</CENTER>
</BODY>
</HTML>