#!/bin/sh
#
# proliferate group <groupid>
# (made from proliferateuser.sh, taking it as example)
#

. $HOME/etc/setenv.sh

GROUPID=""
PROLIFERATE_DATA="false"
DIRECTION="all-backup"

while getopts 'g:dD' OPT; do
	case $OPT in
	g) GROUPID="$OPTARG" ;;
	d) PROLIFERATE_DATA="true" ;;
	D) DIRECTION="${OPTARG}" ;;
	*) usage_ "Invalid_Parameter:$OPT" ;;
	esac   
done

[ -z "$GROUPID" ] && exit 1

if [ "true" = "${PROLIFERATE_DATA}" ] ; then
	${DOTCOM_HOME}/proliferateResource.sh -R "REPOSITORY_USERS" -N "#${GROUPID}" -d "${DIRECTION}"

else
	# proliferate note.txt only
	${DOTCOM_HOME}/proliferateResource.sh -R "REPOSITORY_USERS" -N "#${GROUPID}" -P groupnote.txt -d "${DIRECTION}"
fi

exit 0
