<%@
  page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="
			java.io.*,
			java.sql.*,
			java.text.Format,
			java.util.*,

			imagemed.actions.UserList,
			imagemed.dotcom.DotcomConfig,
			imagemed.exception.*,
			imagemed.http.*,
			imagemed.imsession.*,
			imagemed.imtables.*,
			imagemed.jsputil.*,
			imagemed.layout.LayoutPart,
			imagemed.layout.datasource.*,
			imagemed.lists.*,
			imagemed.tables.*,
			imagemed.types.flag.IMTypeur,
			imagemed.util.*,
			imagemed.users.*
			"

%><%!

	static final String LIST_PARAM_NAME = "cList_" + ListType.USER.getIndex();

%><%

	IMSession is = new IMSession(request, response, out); 
	if ( !is.regOK() ) {
		return;
	}
	IMRequest parReq = is.imRequest;
	String context = parReq.m_context;
	if ( !Table.isExporting( is ) ) {
		if ( context == null || context.length() == 0 ) {
			context = parReq.backupContext();
		}
		else {
			context = parReq.passAsFile( context );
		}
	}
	String returningURL = "/imadmin/users.jsp?cContext=" + context;


	String parListName = request.getParameter( "cListName" );
	String parOper = request.getParameter( "cOper" );
	String parList = parReq.getVal( LIST_PARAM_NAME );
	String parBack = request.getParameter( "cBack" );

	String parID = ""; // TODO szeddki
	
	if ( parList == null )
		parList = "default";

	int idx = parList.indexOf( "/" );
	String parUserId = null;
	User listUser = is.getUser();
	if ( idx != -1 ) {
		parUserId = parList.substring( 0, idx );
		parList = parList.substring( idx + 1 );
	}

	if ( parUserId != null && ! parUserId.isEmpty() ) {
		listUser = new User( parUserId );
	}

	if ( parOper == null )
		parOper = "";

	String parLogged = parReq.getVal( "cLogged" );
	boolean bLogged = "true".equals( parLogged );

	String thisPage = "/imadmin/users.jsp";

	String extraPars[] = { "cLogged" };

	String timeOut = is.secProp.getProperty( "optTimeout" );
	if ( timeOut == null )
		timeOut = "60";
	else
		timeOut = timeOut.replace( '\"', ' ' ).trim();
	String loginPath = IMEnvBase.getEnv( "TMP" ) + "/login";


	boolean shouldRedir = is.request.getParameterMap().containsKey( "cDisposableContext" );

	if ( shouldRedir ) {
		response.sendRedirect( "/imadmin/users.jsp?cContext=" + context );
		return;
	}

	//we must handle SUPPORT here
	if ( !is.hasRight( IMTypeur.USER_MANAGE_RIGHT + IMTypeur.SUPPORT_RIGHT_FOR_SUPPORT_USER ) ) {
		// redirect to groups.jsp - this occurs by clicking on the Tab only
		response.sendRedirect( "/imadmin/groups.jsp" );
		return;
	}

	TableDescriptor tdesc = new TableDescriptor( thisPage );
	TableProperties tprop = new TableProperties();

	WorklistTableParams tparams = new WorklistTableParams( is, is.getProfileUser(), is.regRights.indexOf( 'A' ) > -1, is.isRegisteredViewer() );
	tparams.setDefaults( thisPage, is );
	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( 20 );
	tparams.setExtraParams( extraPars );
	tdesc.setTableParams( tparams );
	tdesc.setSortDepth( 3 );

	tdesc.setTableProperties( tprop );
	//  tdesc.setFieldManager(new IMSQLFieldManager("Dcfields", "Dctypes", "Access"));
	DBLayoutDataSource dblds = EntryLayoutFactory.getDefaultDBLDS( is, LayoutPart.USERLAYOUT );

	FieldManager fm = EntryLayoutFactory.getDefaultFieldManager( is, LayoutPart.USERLAYOUT );
	tdesc.setFieldManager( fm );

	List<Action> acts = new ArrayList<Action>();
//	Action acts[] = new Action[ 5 ];

	//Batch checkbox
	if( is.hasRight( IMTypeur.USER_MANAGE_RIGHT ) ) {
		//not for @support
		acts.add( new CheckboxAction( tprop, "USID", "cGr", null ) );

		acts.add( new LockedUserAction( tdesc, "USID", "javascript:redirPage_b(\"changeuser.jsp?cID=$$USID$$&cOp=Unlock\")",
				"<script language=javascript>" +
						"getImage2node(false, \"semLocked.gif\", 0, 0, \"" + LocalizedMessage.getSimpleMessage( "LOGIN_UNLOCK_USER" ) + "\");" +
						"</script>",
				"<script language=javascript>" +
						"getImage2node(false, \"semUnlocked.gif\", 0, 0, \"" + LocalizedMessage.getSimpleMessage( "STUDY_NOT_LOCKED" ) + "\");" +
						"</script>",		null ) );
	}

	acts.add( new LinkAction( tdesc, "USID", "javascript:redirPage_b(\"changeuser.jsp?cID=$$USID$$&cOp=View\")",
			"<script language=javascript>" +
					"getImage2node(false, \"qview.gif\", 0, 0, \"" + LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_VIEW_DETAILS" ) + "\");" +
					"</script>", null ) );
	acts.add( new ConditionalLinkAction( tdesc, "USID",
			"javascript:redirPage_b(\"changeuser.jsp?cID=$$USID$$&cOp=Edit\")",
			"edit.gif", "18", "20", LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_EDIT_DETAILS" ),
			LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_EDIT_DETAILS" ) ) {

		@Override
		public boolean isButtonThere( IMSession _is, Result result ) {
			// we show those users only for @support user			
			if ( _is.hasRight( IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT ) ) {
				return true;
			}
			String otherGroup = result.getValue( "UGRP", "" );
			if ( otherGroup == null || "".equals( otherGroup ) ) {
				return false;
			}
			return _is.isManaged( otherGroup );
		}
	} );
	acts.add( new ConditionalLinkAction( tdesc, "USID",
			"javascript:redirPage_b(\"changeuser.jsp?cID=$$USID$$&cOp=Delete\")",
			"delete.gif", "18", "20", LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_DELETE_DETAILS" ),
			LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_DELETE_DETAILS" ) ) {

		@Override
		public boolean isButtonThere( IMSession _is, Result result ) {
			// we show those users only for @support user			
			if ( _is.hasRight( IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT ) ) {
				return true;
			}
			String otherGroup = result.getValue( "UGRP", "" );
			if ( otherGroup == null || "".equals( otherGroup ) ) {
				return false;
			}
			return _is.isManaged( otherGroup );
		}
	} );

	Action act[] = new Action[ 2 ];
	act[ 0 ] = new MultiAction( tprop, acts.toArray( new Action[ 0 ] ) );
	act[ 1 ] = new UsersLoggedAction( tprop, "USID",
			"<script language=javascript>" +
					"getImage2node(false, \"/imadmin/art/check.gif\", 0, 0, \"" + LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_SEE_LOGIN_INFO" ) + "\");" +
					"</script>",
			"<script language=javascript>" +
					"getImage2node(false, \"/imadmin/art/cross.gif\", 0, 0, \"" + LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_SEE_LOGIN_INFO" ) + "\");" +
					"</script>" );
	Column col;

	if( is.hasRight( IMTypeur.USER_MANAGE_RIGHT ) ) {
		// not for @support
		Action[] batchAct = new Action[]{ new ComboAction( tdesc, ComboAction.TYPE_USERS_BATCH, "" ) };
		BatchHeader bh = new BatchHeader( batchAct );

	 	col = new Column( bh, new ActionCell( "USID", new Action[]{ new MultiAction( tprop, act ) } ), "USID" );
	}
	else {
		col = new Column( new SimpleHeader( LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_HTMLPAGE_TITLE" ) ), new ActionCell( "USID", act ), "USID" );
	}
	tdesc.addExtraColumn( "_FIRST", col );

	//for batch cOper param to work 
	String uglyAddendum = " method=post>\n<input type=hidden name=\"cOper\" value=\"unset\">\n" +
			"<input type=hidden name=\"cBack\" value=\"" + TableParams.getBackParamsForForms( is ) + "\"";
	tdesc.formParams += uglyAddendum;


	List<TopCell> topCells = new ArrayList<TopCell>();
	//  topCell[0] = new TitleTopCell(tprop, "Users");
	topCells.add( new ListsTopCell( ListType.USER, tdesc, is.getProfileUserId(), true ) );
	topCells.add( new SeparatorTopCell( tprop, 4 ) );


	List<String[]> pageMap = new ArrayList<String[]>();

	if ( is.hasRight( IMTypeur.USER_MANAGE_RIGHT + IMTypeur.SUPPORT_RIGHT_FOR_SUPPORT_USER ) ) {
		pageMap.add( new String[]{ thisPage, LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_USERSLIST" ) } );
	}
	if ( is.hasRight( IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT ) ) {
		pageMap.add( new String[]{ "/imadmin/groups.jsp", LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_GROUPLIST" ) } );
	}
	topCells.add( new PageSelectorTopCell( tprop, pageMap, thisPage ) );

	topCells.add( new SeparatorTopCell( tprop, 4 ) );

	// @support can create and ( UM right with some Managed Groups or Admin or Support ) 
	if ( is.hasRight( IMTypeur.SUPPORT_RIGHT_FOR_SUPPORT_USER + IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT ) ||
			is.m_managedGroupIDs.size() > 0 ) {
		topCells.add( new SimpleTopCell( tprop,
			JSHelper.getJsButtonSLink( is, "javascript:redirPage_b('changeuser.jsp?cOp=New')", "newButton", 0, 0, LocalizedMessage.getSimpleMessage( "ALT_TEXT_CREATE_USER" ) ) ) );
	}
	
	// @support doesn't have this!
	if ( is.hasRight( IMTypeur.USER_MANAGE_RIGHT ) && 
			( is.hasRight( IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT ) ||
				is.m_managedGroupIDs.size() > 0 ) ) {
		topCells.add( new SimpleTopCell( tprop,
				"<A href=\"copy.jsp\" onMouseOver=\"window.status='" +
						"Copy settings'; return true;\">" + JSHelper.getJsButton( is, "copyButton", LocalizedMessage.getSimpleMessage( "ALT_TEXT_COPY_SETTINGS" ) ) + "</a>" ) );
	}

	topCells.add( new SeparatorTopCell( tprop, 4 ) );
	topCells.add( new FieldsTopCell( tdesc, null, true ) );
	topCells.add( new FiltersTopCell( tdesc, null, false, new String[ 0 ], false ) );
	topCells.add( new SortsTopCell( tdesc, null, false, true ) );
	topCells.add( new SeparatorTopCell( tprop, 3 ) );
	topCells.add( new UsersLoggedTopCell( tdesc, bLogged ) );
	topCells.add( new PageTopCell( tprop, tparams ) );

	tdesc.setTopCells( topCells );

	//-----------parOper----------//

	ListFile listFile = new ListFile( listUser, ListType.USER, parListName );
	if ( "Save".equals( parOper ) ) {
		if ( parListName == null || "".equals( parListName ) ) {
			throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_EMPTY" ), "imadmin/users.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_EMPTY_TITLE" ), null );
		}
		if ( !( parListName.indexOf( '\'' ) == -1 && parListName.indexOf( '\t' ) == -1 &&
				parListName.indexOf( '\r' ) == -1 && parListName.indexOf( '\n' ) == -1 &&
				parListName.indexOf( '/' ) == -1 && parListName.indexOf( ';' ) == -1 &&
				parListName.indexOf( '\"' ) == -1 && parListName.indexOf( '\\' ) == -1 && parListName.indexOf( '?' ) == -1 ) ) {
			throw new IMGeneralException( "<CENTER>" + LocalizedMessage.getCompoundMessage( "EXCEPTION_IMADMIN_USERS_LIST_ILLEGAL_CHARS", new Format[]{ null }, new Object[]{ Helper.htmlEncode( parListName ) }, true ) + "</CENTER>", "imadmin/users.jsp", "Userlist Filter Saving", null );
		}

		if ( listFile.exists() ) {
			throw new IMConfirmationException(
					"<CENTER>" + LocalizedMessage.getCompoundMessage( "EXCEPTION_IMADMIN_USERS_LIST_EXISTS", new Format[]{ null }, new Object[]{ Helper.htmlEncode( parListName ) }, true ) + "</CENTER>",
					"imadmin/users.jsp", "List Saving",
					null, returningURL + "&cOper=SaveOverWrite&cListName=" + parListName );
		}
		GenericUserList.saveSimple( parReq, listFile, is );
		listFile.getUserFile().proliferate( ProliferateMode.NORMAL );
		response.sendRedirect( is.httpx_host + "/imadmin/users.jsp?" + LIST_PARAM_NAME + "=" + Helper.URLEncodeUTF8( parListName ) );
	}
	else if ( "SaveOverWrite".equals( parOper ) ) {
		GenericUserList.saveSimple( parReq, listFile, is );
		listFile.getUserFile().proliferate( ProliferateMode.NORMAL );
		response.sendRedirect( is.httpx_host + "/imadmin/users.jsp?" + LIST_PARAM_NAME + "=" + Helper.URLEncodeUTF8( parListName ) );
	}

	//----------------------------//
	if ( Table.isExporting( is ) ) {
		tparams.setPageSize( 0 );
	}
	UsersResult result = new UsersResult( tdesc, dblds, bLogged, loginPath, timeOut );


	result.setRequiredFields( new String[]{ "UGRP", "ULCK" } );


	// if Admin is restricted, show restricted users only
	// we don't show non-manageable users (but we show all for @support)
	String add = IMSession.getQueryPartForLegalUsers();
	if ( !"".equals( add ) ) {
		result.addToWhereClause( new QueryPart( " AND ( " + add + " ) " ) );
	}

	//if logged only is required, show logged users only
	if ( bLogged ) {
		if ( !"".equals( add ) ) {
			result.appendToAddToWhereClause( new QueryPart( result.generateLoggedWhereClause() ) );
		}
		else {
			result.addToWhereClause( new QueryPart( result.generateLoggedWhereClause() ) );
		}
	}

	tdesc.setResult( result );


	Table table = new Table( tdesc );
//	table.setImportable( true );
	if ( table.handleExport( is ) ) {
		return;
	}

%><HTML>
  <HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "IMADMIN_USERS_HTMLPAGE_TITLE" ) %></TITLE>
 <SCRIPT Language="JavaScript">
 	var pageContext="<%=context%>";
 </script>
<%
	TabToolbox.writeIMpopup( out );
	table.printScript( tparams, is );
%>
    <script language="JavaScript">
    
    function doSubmit(frm,val) {
        frm.cLogged.value = val;
        frm.submit();
    }
      
	function Batch_( op ) {
		self.document.Batch.cOper.value = op;
		self.document.Batch.submit();	    
	}

    </script>
                                
    </HEAD>
    <BODY><CENTER>
<%
	TabToolbox.makeTabs( is, is.tabbean, "imadmin/users.jsp", "White" );

    // Batch parOper
  	if ( parOper != null && parOper.startsWith( "Batch" ) ) {
  		if ( "BatchUnlock".equals(parOper) ) {
  			String[] users = is.imRequest.getVals( "cGr" );
  			if( users == null || users.length == 0 ) {
  				response.sendRedirect( parBack );
  				return;
  			}
  			else {
  				List<String> lockedUsers = new ArrayList<String>();
  				for( int i = 0; i < users.length; i++ ) {
					if( UserLockToolbox.isUserLocked( users[ i ] ) ) {
						lockedUsers.add( users[ i ] );
					}
  				}
  				
  				%>
  				<FORM name="operForm" method="POST" action="<%=thisPage%>">
  				<CENTER><TABLE border=1 cellpadding=0 cellspacing=0 width="60%">
  						<%=Helper.header3D(LocalizedMessage.getSimpleMessage( "IMADMIN_CHUSER_CONFIRMATION" ))%>
  					<TR>
  						<TD class=BgLight align="center">
  						<H2><BR>
  						<%= LocalizedMessage.getSimpleMessage( lockedUsers.size() == 0 ? "IMADMIN_CHUSER_UNLOCK_NOUSER" : "IMADMIN_CHUSER_UNLOCK_WARNING_PLURAL" ) %>
  						<P>
  						<%
							for( int i = 0; i < lockedUsers.size(); i++ ) {
								out.print( lockedUsers.get( i ) + ( i < lockedUsers.size() - 1 ? ", " : "" ) );
							}
  						%>
  						<P><%= ( lockedUsers.size() == 0 ? "" : LocalizedMessage.getSimpleMessage( "IMADMIN_CHUSER_DELETE_CONFIRM" ) ) %> <BR>
  						<BR>
  						</H2>
  						</TD>
  					</TR>
  					<TR>
  						<TD class=BgShadow nowrap align=right><BR>
  					<%
  						if( lockedUsers.size() > 0 ) {
  							for( int i = 0; i < lockedUsers.size(); i++ ) {
  					%>
  								<input type=hidden name="cGr" value="<%=lockedUsers.get( i )%>">
  					<%
  							}
  					%>
  							<input type=hidden name="cBack" value="<%=parBack%>">
  							<%= JSHelper.getJsInputLocalizedButton(is, "BUTTON_UNLOCK", "cOper", "BatchUnlockSure") %>
  							&nbsp; &nbsp; &nbsp; &nbsp;
  					<%
  						}
  					%>
  							<a href="<%=parBack%>"><%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %></script></a>
  						</TD>
  					</TR>
  					<TR>
  						<TD class=FieldBlock></td>
  					</tr>
  				</table></CENTER>
  				</FORM>
  				</body>
  				</html>
  				<%	
  				return;
  			}
  		}
  		else if( "BatchUnlockSure".equals(parOper) ) {
  			String[] users = is.imRequest.getVals( "cGr" );
  			UserLockToolbox.unlockUsers( users );
  			response.sendRedirect( parBack );
  			return;
  		}
  		else if ( "BatchDelete".equals(parOper) ) {
  			String[] users = is.imRequest.getVals( "cGr" );
  			if( users == null || users.length == 0 ) {
  				response.sendRedirect( parBack );
  				return;
  			}
  			else {
  				%>
  				<FORM name="operForm" method="POST" action="<%=thisPage%>">
  				<CENTER><TABLE border=1 cellpadding=0 cellspacing=0 width="60%">
  						<%=Helper.header3D(LocalizedMessage.getSimpleMessage( "IMADMIN_CHUSER_CONFIRMATION" ))%>
  					<TR>
  						<TD class=BgLight align="center">
  						<H2><BR>
  						<%= LocalizedMessage.getSimpleMessage( "IMADMIN_CHUSER_DELETE_WARNING_PLURAL" ) %>
  						<P>
  						<%
							for( int i = 0; i < users.length; i++ ) {
								out.print( users[ i ] + ( i < users.length - 1 ? ", " : "" ) );
							}
  						%>
  						<P><%= LocalizedMessage.getSimpleMessage( "IMADMIN_CHUSER_DELETE_CONFIRM" ) %> <BR>
  						<BR>
  						</H2>
  						</TD>
  					</TR>
  					<TR>
  						<TD class=BgShadow nowrap align=right><BR>
  					<%
  							for( int i = 0; i < users.length; i++ ) {
  					%>
  								<input type=hidden name="cGr" value="<%=users[ i ]%>">
  					<%
  							}
  					%>
  							<input type=hidden name="cBack" value="<%=parBack%>">
  							<%= JSHelper.getJsInputLocalizedButton(is, "BUTTON_DELETE", "cOper", "BatchDeleteSure") %>
  							&nbsp; &nbsp; &nbsp; &nbsp;
  							<a href="<%=parBack%>"><%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %></script></a>
  						</TD>
  					</TR>
  					<TR>
  						<TD class=FieldBlock></td>
  					</tr>
  				</table></CENTER>
  				</FORM>
  				</body>
  				</html>
  				<%	
  				return;
  			}
  		}
  		else if( "BatchDeleteSure".equals(parOper) ) {
  			String[] users = is.imRequest.getVals( "cGr" );
  			for( int i = 0; i < users.length; i++ ) {
  				if (!IMAdminToolbox.deleteUser(is, users[ i ] )) {
  					throw new imagemed.exception.IMUserAdminException( LocalizedMessage.getSimpleMessage( "EXCEPTION_CHUSER_ERROR_DELETE" )+  ": " + users[ i ]);
  				}
  			}

  			response.sendRedirect( parBack );
  			return;
  		}
  	}
    
    
    
	if ( !is.hasRight( IMTypeur.USER_MANAGE_RIGHT + IMTypeur.SUPPORT_RIGHT_FOR_SUPPORT_USER ) ) {
%>
  <BR>
  <H3><%= LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ) %></H3></CENTER>
  </BODY></HTML>
<%
		return;
	}
	try {
		table.printTableTop( is );
	}
	catch ( Throwable th ) {
		Helper.DEBUG( "users.jsp", Helper.throwable2String( th ) );
	}
	table.print( is );
%>
</CENTER>
<%
	// UM right only and no Groups doesn't save lists
	if( is.m_managedGroupIDs.size() > 0 || is.hasRight( IMTypeur.ADMIN_RIGHT + IMTypeur.SUPPORT_RIGHT )) {
		is.out.print( ListSaveForm.getListSaveForm( ListType.USER, is, tdesc ) );
	}
%>

</BODY></HTML>
